Create a strategy chain atomically
curl --request POST \
--url https://atollhq.com/api/orgs/{id}/strategy/setup \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"idempotency_key": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"goal_title": "<string>",
"kpi_name": "<string>",
"product_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"goal_description": "<string>",
"goal_target_date": "2023-12-25",
"unit": "count",
"target_direction": "increase",
"current_value": 123,
"target_value": 123,
"initiative_title": "<string>",
"expected_impact": "<string>"
}
'import requests
url = "https://atollhq.com/api/orgs/{id}/strategy/setup"
payload = {
"idempotency_key": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"goal_title": "<string>",
"kpi_name": "<string>",
"product_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"goal_description": "<string>",
"goal_target_date": "2023-12-25",
"unit": "count",
"target_direction": "increase",
"current_value": 123,
"target_value": 123,
"initiative_title": "<string>",
"expected_impact": "<string>"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
idempotency_key: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
goal_title: '<string>',
kpi_name: '<string>',
product_id: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
goal_description: '<string>',
goal_target_date: '2023-12-25',
unit: 'count',
target_direction: 'increase',
current_value: 123,
target_value: 123,
initiative_title: '<string>',
expected_impact: '<string>'
})
};
fetch('https://atollhq.com/api/orgs/{id}/strategy/setup', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://atollhq.com/api/orgs/{id}/strategy/setup",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'idempotency_key' => '3c90c3cc-0d44-4b50-8888-8dd25736052a',
'goal_title' => '<string>',
'kpi_name' => '<string>',
'product_id' => '3c90c3cc-0d44-4b50-8888-8dd25736052a',
'goal_description' => '<string>',
'goal_target_date' => '2023-12-25',
'unit' => 'count',
'target_direction' => 'increase',
'current_value' => 123,
'target_value' => 123,
'initiative_title' => '<string>',
'expected_impact' => '<string>'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://atollhq.com/api/orgs/{id}/strategy/setup"
payload := strings.NewReader("{\n \"idempotency_key\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"goal_title\": \"<string>\",\n \"kpi_name\": \"<string>\",\n \"product_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"goal_description\": \"<string>\",\n \"goal_target_date\": \"2023-12-25\",\n \"unit\": \"count\",\n \"target_direction\": \"increase\",\n \"current_value\": 123,\n \"target_value\": 123,\n \"initiative_title\": \"<string>\",\n \"expected_impact\": \"<string>\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://atollhq.com/api/orgs/{id}/strategy/setup")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"idempotency_key\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"goal_title\": \"<string>\",\n \"kpi_name\": \"<string>\",\n \"product_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"goal_description\": \"<string>\",\n \"goal_target_date\": \"2023-12-25\",\n \"unit\": \"count\",\n \"target_direction\": \"increase\",\n \"current_value\": 123,\n \"target_value\": 123,\n \"initiative_title\": \"<string>\",\n \"expected_impact\": \"<string>\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://atollhq.com/api/orgs/{id}/strategy/setup")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"idempotency_key\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"goal_title\": \"<string>\",\n \"kpi_name\": \"<string>\",\n \"product_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"goal_description\": \"<string>\",\n \"goal_target_date\": \"2023-12-25\",\n \"unit\": \"count\",\n \"target_direction\": \"increase\",\n \"current_value\": 123,\n \"target_value\": 123,\n \"initiative_title\": \"<string>\",\n \"expected_impact\": \"<string>\"\n}"
response = http.request(request)
puts response.read_body{
"setup": {
"goal_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"kpi_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"initiative_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}
}{
"error": "Unauthorized",
"code": "unauthorized"
}{
"error": "Unauthorized",
"code": "unauthorized"
}{
"error": "Unauthorized",
"code": "unauthorized"
}{
"error": "Unauthorized",
"code": "unauthorized"
}{
"error": "Unauthorized",
"code": "unauthorized"
}Strategy
Create a strategy chain atomically
Organization owner/admin and projectless strategy write access required. Creates a goal, manual KPI, optional initial snapshot, optional initiative and impact link in one transaction. An identical actor-scoped idempotency key replays original IDs; changed input returns 409. Failure leaves no partial chain. Product ownership permissions and archive restrictions apply.
POST
/
api
/
orgs
/
{id}
/
strategy
/
setup
Create a strategy chain atomically
curl --request POST \
--url https://atollhq.com/api/orgs/{id}/strategy/setup \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"idempotency_key": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"goal_title": "<string>",
"kpi_name": "<string>",
"product_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"goal_description": "<string>",
"goal_target_date": "2023-12-25",
"unit": "count",
"target_direction": "increase",
"current_value": 123,
"target_value": 123,
"initiative_title": "<string>",
"expected_impact": "<string>"
}
'import requests
url = "https://atollhq.com/api/orgs/{id}/strategy/setup"
payload = {
"idempotency_key": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"goal_title": "<string>",
"kpi_name": "<string>",
"product_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"goal_description": "<string>",
"goal_target_date": "2023-12-25",
"unit": "count",
"target_direction": "increase",
"current_value": 123,
"target_value": 123,
"initiative_title": "<string>",
"expected_impact": "<string>"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
idempotency_key: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
goal_title: '<string>',
kpi_name: '<string>',
product_id: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
goal_description: '<string>',
goal_target_date: '2023-12-25',
unit: 'count',
target_direction: 'increase',
current_value: 123,
target_value: 123,
initiative_title: '<string>',
expected_impact: '<string>'
})
};
fetch('https://atollhq.com/api/orgs/{id}/strategy/setup', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://atollhq.com/api/orgs/{id}/strategy/setup",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'idempotency_key' => '3c90c3cc-0d44-4b50-8888-8dd25736052a',
'goal_title' => '<string>',
'kpi_name' => '<string>',
'product_id' => '3c90c3cc-0d44-4b50-8888-8dd25736052a',
'goal_description' => '<string>',
'goal_target_date' => '2023-12-25',
'unit' => 'count',
'target_direction' => 'increase',
'current_value' => 123,
'target_value' => 123,
'initiative_title' => '<string>',
'expected_impact' => '<string>'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://atollhq.com/api/orgs/{id}/strategy/setup"
payload := strings.NewReader("{\n \"idempotency_key\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"goal_title\": \"<string>\",\n \"kpi_name\": \"<string>\",\n \"product_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"goal_description\": \"<string>\",\n \"goal_target_date\": \"2023-12-25\",\n \"unit\": \"count\",\n \"target_direction\": \"increase\",\n \"current_value\": 123,\n \"target_value\": 123,\n \"initiative_title\": \"<string>\",\n \"expected_impact\": \"<string>\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://atollhq.com/api/orgs/{id}/strategy/setup")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"idempotency_key\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"goal_title\": \"<string>\",\n \"kpi_name\": \"<string>\",\n \"product_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"goal_description\": \"<string>\",\n \"goal_target_date\": \"2023-12-25\",\n \"unit\": \"count\",\n \"target_direction\": \"increase\",\n \"current_value\": 123,\n \"target_value\": 123,\n \"initiative_title\": \"<string>\",\n \"expected_impact\": \"<string>\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://atollhq.com/api/orgs/{id}/strategy/setup")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"idempotency_key\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"goal_title\": \"<string>\",\n \"kpi_name\": \"<string>\",\n \"product_id\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"goal_description\": \"<string>\",\n \"goal_target_date\": \"2023-12-25\",\n \"unit\": \"count\",\n \"target_direction\": \"increase\",\n \"current_value\": 123,\n \"target_value\": 123,\n \"initiative_title\": \"<string>\",\n \"expected_impact\": \"<string>\"\n}"
response = http.request(request)
puts response.read_body{
"setup": {
"goal_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"kpi_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"initiative_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}
}{
"error": "Unauthorized",
"code": "unauthorized"
}{
"error": "Unauthorized",
"code": "unauthorized"
}{
"error": "Unauthorized",
"code": "unauthorized"
}{
"error": "Unauthorized",
"code": "unauthorized"
}{
"error": "Unauthorized",
"code": "unauthorized"
}Authorizations
Bearer authentication header of the form Bearer <token>, where <token> is your auth token.
Path Parameters
Body
application/json
Available options:
count, percentage, currency, duration, ratio, custom Available options:
increase, decrease, maintain Response
Created or replayed chain
Show child attributes
Show child attributes

